#include <iostream>
#include <fstream>
#define MAXN 100003
#define MAXM 500003
#define INF 100000000
using namespace std;

int n,m,k;
int hmin,kmin;
int nr1[MAXM]; //numarul de 1 de pe fiecare coloana
int x,y;
int maxS[MAXM];
int maxD[MAXM];

void solve_good() {
    maxS[0] = 0;
    for(int i=1; i<=m; i++)
        maxS[i] = max(maxS[i-1],nr1[i]);
    maxD[m+1] = 0;
    for(int i=m; i>=1; i--)
        maxD[i] = max(maxD[i+1],nr1[i]);

    for(int i=1; i<=m-k; i++)
        hmin = min(hmin,max(maxS[i-1],maxD[i+k]));

    int lb=0,ub=k; //lower_bound, upper_bound pentru BinarySearch
    int kt;
    int hcmin;
    while (lb<=ub) {
        hcmin = INF;
        kt = (lb+ub)/2;
        for(int i=1; i<=m-kt; i++)
            hcmin = min(hcmin,max(maxS[i-1],maxD[i+kt]));
        if (hcmin==hmin)
            kmin = min(kmin,kt);

        if (hcmin>hmin) lb = kt+1;
        else if (hcmin==hmin) ub = kt-1;
    }
}

int main() {
    ifstream fin("placa.in");
    ofstream fout("placa.out");
    fin>>n>>m>>k;
    for(int j=1; j<=m; j++) {
            fin>>x>>y;
            nr1[j]=x+y;
        }

    fin.close();

    hmin = INF;
    kmin = INF;

    solve_good();

    fout<<hmin<<"\n"<<kmin<<"\n";
    fout.close();
    return 0;
}
